# fdisk磁盘分区



### Fdisk  命令

```
fdisk [必要参数][选择参数]
```

必要参数

- -l 列出素所有分区表
- -u 与 **-l** 搭配使用，显示分区数目



选择参数

- -s<分区编号> 指定分区
- -v 版本信息



菜单操作说明

- m ：显示菜单和帮助信息
- a ：活动分区标记/引导分区
- d ：删除分区
- l ：显示分区类型
- n ：新建分区
- p ：显示分区信息
- q ：退出不保存
- t ：设置分区号
- v ：进行分区检查
- w ：保存修改
- x ：扩展应用，高级功能



实例

```
# fdisk -l

Disk /dev/sda: 10.7 GB, 10737418240 bytes
255 heads, 63 sectors/track, 1305 cylinders
Units = cylinders of 16065 * 512 = 8225280 bytes

  Device Boot   Start     End   Blocks  Id System
/dev/sda1  *      1     13   104391  83 Linux
/dev/sda2       14    1305  10377990  8e Linux LVM

Disk /dev/sdb: 5368 MB, 5368709120 bytes
255 heads, 63 sectors/track, 652 cylinders
Units = cylinders of 16065 * 512 = 8225280 bytes

Disk /dev/sdb doesn't contain a valid partition table
```





新建分区

```
fdisk /dev/sdb   

输入 n
按提示操作 

最后输入W 保存
```



格式化分区

```
mkfs.ext3 /dev/sdb1
```

格式化磁盘

```
mkfs.ext3 /dev/sdb
```



挂载分区

编辑文件 
```bash
vim /etc/fstab
```

```bash
/dev/sdb1   /opt       ext4    defaults    0 0
```

 临时挂载

```bash
mount  /dev/sdb1 /Public2
```



### lsblk 命令

查看硬盘信息
```
lsblk
```
```
lsblk -f
```
```
[root@worker ~]# lsblk
NAME            MAJ:MIN RM  SIZE RO TYPE MOUNTPOINT
sda               8:0    0   30G  0 disk
├─sda1            8:1    0  200M  0 part /boot/efi
├─sda2            8:2    0    1G  0 part /boot
└─sda3            8:3    0 28.8G  0 part
  ├─centos-root 253:0    0   27G  0 lvm  /
  └─centos-swap 253:1    0  1.8G  0 lvm  [SWAP]
sdb               8:16   0    1T  0 disk
└─sdb1            8:17   0 1024G  0 part /opt
sr0              11:0    1 1024M  0 rom
```





