### oracle 数据库 job 操作



**停止job**  `force => TRUE` 不检查任务是否正在运行强制停止

```sql
BEGIN
  DBMS_SCHEDULER.STOP_JOB(job_name => 'TEST_JOB', force => TRUE);
END;
```



**删除job** `force => TRUE` 不检查任务是否正在运行强制删除

```sql
BEGIN
  DBMS_SCHEDULER.DROP_JOB(job_name => 'TEST_JOB');
END;

```



**创建job** 

```
BEGIN
  DBMS_SCHEDULER.CREATE_JOB (
    job_name        => 'MC_CH_ISSUE_INFO_CLEAN_NEW',
    job_type        => 'PLSQL_BLOCK',
    job_action      => 'BEGIN MC_CH_ISSUE_INFO_CLEAN_EVD; END;',
    start_date      => SYSTIMESTAMP,
    repeat_interval => 'FREQ=DAILY; BYHOUR=8; BYMINUTE=25;',
    enabled         => TRUE
  );
END;
```



停止执行计划

```
BEGIN
  DBMS_SCHEDULER.DISABLE('MC_CH_ISSUE_INFO_CLEAN');
END;
```



运行一个计划

```
BEGIN
  DBMS_SCHEDULER.RUN_JOB('test_job');
END;
```

